include \masm32\include\masm32rt.inc
.686p

IDT_PROGGRESSBAR	EQU 100
WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

.data?
	hInstance	HINSTANCE	?
	hGlobalDC	HWND		?
	hBitmap		HBITMAP		?
	
	rcPBar		RECT		<>	; progress bar's rectangle (client coord.)
	r4PBar		REAL4		?	; current value of progress bar: 0...1 == 0...100%
	
	hBtnRegion	HRGN		?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,0
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"ProgrssBarDemo",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,500,300,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

; this procedure draws the progress bar
UpdatePBar proc uses edi esi ebx hWnd:HWND,hDC:HDC,pRect: ptr RECT,value:REAL4
LOCAL x:DWORD
LOCAL hBr:HBRUSH
LOCAL hPen:HPEN
LOCAL bkMode:DWORD
LOCAL bkColor:COLORREF
LOCAL sz[128]:CHAR
LOCAL r8:REAL8

	mov esi,pRect

	; draw frame
	mov hBr,rv(SelectObject,hDC,rv(CreateSolidBrush,0ffffffh))
	mov hPen,rv(SelectObject,hDC,rv(CreatePen,PS_SOLID,1,0))
	invoke Rectangle,hDC,[esi].RECT.left,[esi].RECT.top,[esi].RECT.right,[esi].RECT.bottom
	invoke DeleteObject,rv(SelectObject,hDC,hPen)
	invoke DeleteObject,rv(SelectObject,hDC,hBr)

	; calcualte width and hight
	mov ebx,[esi].RECT.right
	sub ebx,[esi].RECT.left
	mov edi,[esi].RECT.bottom
	sub edi,[esi].RECT.top	
	sub ebx,2
	sub edi,2

	; calculate current pos.
	mov x,ebx
	fild x
	fmul value
	fistp x
	.if x <= ebx
		mov ebx,x
	.endif
	
	; draw progrss bar
	mov hBr,rv(SelectObject,hDC,rv(CreateSolidBrush,0e0e0e0h))
	mov hPen,rv(SelectObject,hDC,rv(CreatePen,PS_SOLID,1,0e0e0e0h))
	mov ecx,[esi].RECT.left
	mov edx,[esi].RECT.top
	invoke Rectangle,hDC,ADDR[ecx+1],ADDR [edx+1],ADDR [ecx+ebx+1],ADDR [edx+edi+1]
	invoke DeleteObject,rv(SelectObject,hDC,hPen)
	invoke DeleteObject,rv(SelectObject,hDC,hBr)	

	; save current BkMOde/Color
	mov bkMode,rv(GetBkMode,hDC)
	mov bkColor,rv(GetBkColor,hDC)
	
	; new mode and color
	invoke SetBkMode,hDC,TRANSPARENT
	invoke SetBkColor,hDC,0
	
	fld value
	fmul FP4(100.0)
	fstp r8
	fn crt_sprintf,ADDR sz,"%.0f%%",r8
	invoke DrawText,hDC,ADDR sz,len(ADDR sz),pRect,DT_CENTER or DT_VCENTER or DT_SINGLELINE

	; restore state
	invoke SetBkColor,hDC,bkColor
	invoke SetBkMode,hDC,bkMode

	; update only our progress bar
	invoke InvalidateRect,hWnd,pRect,0

	ret
	
UpdatePBar endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL x:DWORD

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		; clean up resources
		mov hBitmap,rv(SelectObject,hGlobalDC,hBitmap)
		invoke DeleteObject,hBitmap
		invoke DeleteDC,hGlobalDC
		invoke DeleteObject,hBtnRegion
	.elseif uMsg == WM_CREATE
	
		; load bitmap
		mov hBitmap,rv(LoadImage,0,"UI.bmp",IMAGE_BITMAP,0,0,LR_DEFAULTSIZE or LR_LOADFROMFILE)
		.if !hBitmap
			fn MessageBox,0,"Can't load file: UI.bmp","error",MB_OK
			invoke ExitProcess,0
		.endif
		
		; create DC
		mov ebx,rv(GetDC,rv(GetDesktopWindow))
		mov hGlobalDC,rv(CreateCompatibleDC,ebx)
		invoke ReleaseDC,rv(GetDesktopWindow),ebx
		
		; select bitmap and save unselected bitmap
		mov hBitmap,rv(SelectObject,hGlobalDC,hBitmap)
		
		; declare the rectangle of our progerss bar
		mov rcPBar.left,10
		mov rcPBar.top,10
		mov rcPBar.right,10+450
		mov rcPBar.bottom,10+30
		
		; create some event, which change progress bar's value
		invoke SetTimer,hWnd,IDT_PROGGRESSBAR,100,0
		
		; create region for the OK-button
		mov hBtnRegion,rv(CreateEllipticRgn,230-45,200-45,230+45,200+45)
		
	.elseif uMsg == WM_TIMER
		.if wParam == IDT_PROGGRESSBAR
			fld r4PBar
			fadd FP4(0.01)	; + 1%
			fld st
			fmul FP4(100.0)
			fistp x
			fstp r4PBar
			.if x > 100
				mov r4PBar,0
			.endif
			invoke UpdatePBar,hWnd,hGlobalDC,ADDR rcPBar,r4PBar
		.endif
	.elseif uMsg == WM_PAINT
		; copy requested rectangle from back buffer to screen
	    invoke BeginPaint,hWnd,ADDR ps
	    mov edx,ps.rcPaint.right
	    sub edx,ps.rcPaint.left
	    mov ecx,ps.rcPaint.bottom
	    sub ecx,ps.rcPaint.top
	    invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hGlobalDC,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
	    invoke EndPaint,hWnd,ADDR ps
	.elseif uMsg == WM_LBUTTONDOWN
		movzx eax,WORD ptr lParam
		movzx edx,WORD ptr lParam+2
		.if rv(PtInRegion,hBtnRegion,eax,edx)
			invoke PostQuitMessage,NULL
			invoke DestroyWindow,hWnd
		.endif		
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
